#!/usr/bin/perl -wT
use strict;
use warnings;
use Elchemea qw(EFAlog);
use SocketClient qw(serial_client);
my $tty = 0; ### Assumes default serial port ttyS0 ####
my $address = 1;
my $sleep = 5;
my $totaltime = 2*$sleep+2;
my $debugf = '/home/elchemea/DC-autooffset.txt';
exit unless ($address);
foreach (@ARGV)
{
    next unless /test/;
    print $totaltime,"\n";
    exit;
}
$tty = shift if (@ARGV);
my @chrs = (0,1);
### Set out to 0 V ###
sleep(1);
foreach (@chrs)
{
    serial_client($tty,'volt_set',$_+2,1,0);
}
sleep($sleep);
my @v = &get_data();
foreach (@chrs)
{
    my $setv = $v[$_] * 0.0198;  ## Value determined by callibration at 16 A ##
    ### Set output voltage ###
    serial_client($tty,'volt_set',$_+2,1,$setv);
}
sleep($sleep);
@v = &get_data();
foreach (@chrs)
{
    my $volt = 4 * $v[$_];
    &mlog("Channel $_: Residual offset voltage: $volt mV");
}


my @vals = &get_data();
print $vals[2] * 9.3/1000 ,"\n";  ### Hardcoded multiplication due to voltage divide
exit;


sub mlog($)
{
    my $str = shift;
    return unless $str;
    chomp $str;
    my $t = localtime();
    open MYOUT,'>>',$debugf or die EFAlog("Could not open file $debugf for appending: $!");
    print MYOUT "$t $str\n";
    close MYOUT;
}

sub get_data()
{
    my $str = serial_client($tty,'icp7017read',1);
    return split(/\n/,$str);
}
