#!/usr/bin/perl
use Sys::Hostname;
use SOAP::Lite;
our @SOAP_ERRORS = ();
my $hostname = hostname;
my $wsdl = "http://$hostname/wsdl/timeslot.wsdl";
my $soap = SOAP::Lite->on_fault(\&soapGetBad)->service($wsdl);
my $cmd = shift;
my @argv = ARGV;
print join("\n",$soap->$cmd(@ARGV)),"\n";
exit;




sub soapGetBad {
    my $soap = shift;
    my $res = shift;
    if( ref( $res ) ) {
        chomp( my $err = $res->faultstring );
        push( @SOAP_ERRORS, "SOAP FAULT: $err" );
    }
    else {
        chomp( my $err = $soap->transport->status );
        push( @SOAP_ERRORS, "TRANSPORT ERROR: $err" );
    }
    warn join(@SOAP_ERRORS),"\n";
    return new SOAP::SOM;
}
